//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DimGray
#property indicator_color4  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2

extern int SmoothPeriod = 14;

//
//
//
//
//

double bb[];
double bs[];
double vols[];
double volb[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, bs); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, bb); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2, vols);
   SetIndexBuffer(3, volb);

     IndicatorShortName("Buy Sell presure volume ["+SmoothPeriod+"]");
   return(0);
}

//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      double alpha = 2.0 / (1.0 + SmoothPeriod);
      for(int i=limit; i>=0; i--)
      {
         double volume = 0; 
            if (Close[i]>iMA(NULL,0,SmoothPeriod,0,MODE_SMA,PRICE_CLOSE,i)) volume =  Volume[i];
            if (Close[i]<iMA(NULL,0,SmoothPeriod,0,MODE_SMA,PRICE_CLOSE,i)) volume = -Volume[i];
      
            bb[i] = EMPTY_VALUE;
            bs[i] = EMPTY_VALUE;
            if (volume>0) 
                  { volb[i] = volb[i+1]+alpha*(volume-volb[i+1]); bb[i] = volb[i]; }
            else  { volb[i] = volb[i+1]; }
            if (volume<0)
                  { vols[i] = vols[i+1]+alpha*(volume-vols[i+1]); bs[i] = vols[i]; }
            else  { vols[i] = vols[i+1]; }
      }
   return(0);
}